{% extends 'store/main.html' %}
{% load static %}
{% block content %}
     <div class="row">
          <div class="col-lg-6">
               <div class="box-element" id="form-wrapper">
                    <form id="form">
                         <div id="user-info">
                              <div class="form-field">
                                   <input required class="form-control" type="text" name="name" placeholder="Name..">
                              </div>
                              <div class="form-field">
                                   <input required class="form-control" type="email" name="email" placeholder="Email..">
                              </div>
                         </div>
                         
                         <div id="shipping-info">
                              <hr>
                              <p>Shipping Information:</p>
                              <hr>
                              <div class="form-field">
                                   <input class="form-control" type="text" name="address" placeholder="Address..">
                              </div>
                              <div class="form-field">
                                   <input class="form-control" type="text" name="city" placeholder="City..">
                              </div>
                              <div class="form-field">
                                   <input class="form-control" type="text" name="state" placeholder="State..">
                              </div>
                              <div class="form-field">
                                   <input class="form-control" type="text" name="zipcode" placeholder="Zip code..">
                              </div>
                              <div class="form-field">
                                   <input class="form-control" type="text" name="country" placeholder="Zip code..">
                              </div>
                         </div>

                         <hr>
                         <input id="form-button" class="btn btn-success btn-block" type="submit" value="Continue">
                    </form>
               </div>

               <br>
               <div class="box-element hidden" id="payment-info">
                    <small>Paypal Options</small>
                    <button id="make-payment">Make payment</button>
               </div>
               
          </div>

          <div class="col-lg-6">
               <div class="box-element">
                    <a  class="btn btn-outline-dark" href="{% url 'cart' %}">&#x2190; Back to Cart</a>
                    <hr>
                    <h3>Order Summary</h3>
                    <hr>
                    {% for item in items %}
                    <div class="cart-row">
                         <div style="flex:2"><img class="row-image" src="{{item.product.imageURL}}"></div>
                         <div style="flex:2"><p>{{item.product.name}}</p></div>
                         <div style="flex:1"><p>${{item.product.price|floatformat:2}}</p></div>
                         <div style="flex:1"><p>x{{item.quantity}}</p></div>
                    </div>
                    {% endfor %}
                    <h5>Items:   {{order.get_cart_items}}</h5>
                    <h5>Total:   ${{order.get_cart_total|floatformat:2}}</h5>
               </div>
          </div>
     </div>

     <script type="text/javascript">
          var shipping = '{{order.shipping}}'
          var total = '{{order.get_cart_total}}'

          if (shipping == 'False'){
               document.getElementById('shipping-info').innerHTML = ''
          }

          if (user != 'AnonymousUser'){
               document.getElementById('user-info').innerHTML = ''
          }

          if (shipping == 'False' && user != 'AnonymousUser'){
               //Hide entire from if user is logged in and shipping is false
               document.getElementById('form-wrapper').classList.add("hidden");
               //Show payment if logged in user wants to buy an item that does not require 
              shipping
              document.getElementById('payment-info').classList.remove("hidden") 
          }

          var form = document.getElementById('form')
          form.addEventListener('submit', function(e){
               e.preventDefault()
               console.log('Form Submitted...')
               document.getElementById('form-button').classList.add("hidden");
               document.getElementById('payment-info').classList.remove("hidden");
          })

          document.getElementById('make-payment').addEventListener('click', function(e){
               submitFormData()
          })

          function submitFormData(){
               console.log('Payment button clicked')

               var userFormData = {
                    'name':null,
                    'email':null,
                    'total':total,
               }

               var shippinginfo = {
                    'address':null,
                    'city':null,
                    'state':null,
                    'zipcode':null,
               }

               if(shipping != 'False'){
                    shippinginfo.address = form.address.value
                    shippinginfo.city = form.city.value
                    shippinginfo.state = form.state.value
                    shippinginfo.zipcode = form.zipcode.value
               }

               if(user == 'AnonymousUser'){
                    AnonymousUser.name = form.name.value
                    AnonymousUser.email = form.email.value
               }

               var url = "/process_order/"
               fetch(url, {
                    method: 'POST',
                    headers: {
                         'Content-Type': 'application/json',
                         'X-CSRFToken': csrftoken,
                    },
                    body: JSON.stringify({ 'form': userFormData, 'shipping': shippinginfo })
               })
               .then((response) => response.json())
               .then((data) => {
                    console.log('Success:', data);
                    alert('Transaction completed');

                    cart = {}
                   document.cookie = 'cart=' + JSON.stringify(cart) + ";domain=;path=/" 

                    window.location.href = "{% url 'store' %}"
               })
          }
     </script>
{% endblock content %}